﻿using System.Collections.Generic;
using FluentAssertions;
using Xunit;

namespace Robware.Lib.ApiClient.Tests {
	public class CacheDurationsTests {
		[Fact]
		public void Index_WithExistingKey_ReturnsDuration() {
			var duration = new CacheDurations {{"class", new Dictionary<string, int> {{"method", 1}}}};
			duration["class:method"].Should().Be(1);
		}

		[Fact]
		public void Index_WithNonExistentKey_ReturnsDefault() {
			var duration = new CacheDurations {{"default", new Dictionary<string, int> {{"default", 1}}}};
			duration["key"].Should().Be(1);
		}

		[Fact]
		public void Index_WithNonExistentMethodKey_ReturnsDefaultForClass() {
			var duration = new CacheDurations {{"class", new Dictionary<string, int> {{"default", 1}}}};
			duration["class:method"].Should().Be(1);
		}

		[Fact]
		public void Index_WithNonexistentKey_WithoutDefaultDefined_ReturnsZero() {
			var duration = new CacheDurations();
			duration["key"].Should().Be(0);
		}
	}
}